import { BaseClient, ClientConfig, Response } from "@commerce-apps/core";
import type { OperationOptions } from "retry";
import type { RequestInit } from "node-fetch";
export declare namespace CdnZones {
    type FirewallRule = {
        firewallruleId?: string;
        zoneId: string;
        type: string;
        action: string;
        values: Array<string>;
    } & {
        [key: string]: any;
    };
    type CachePurgeRequest = {
        path: string;
    } & {
        [key: string]: any;
    };
    type CachePurgeResponseEnvelope = {
        data: CachePurgeResponse;
    } & {
        [key: string]: any;
    };
    type CollectionResponseEnvelope = {
        data?: Array<any>;
    } & {
        [key: string]: any;
    };
    type StorefrontZoneCreateResponse = {
        zoneId: string;
        zoneName: string;
        status: string;
        createdOn: any;
    } & {
        [key: string]: any;
    };
    type WafGroupEnvelope = {
        data: WafGroup;
    } & {
        [key: string]: any;
    };
    type LogpushOwnershipPostRequest = {
        destinationPath: string;
    } & {
        [key: string]: any;
    };
    type SpeedSettingsEnvelope = {
        data: SpeedSetting;
    } & {
        [key: string]: any;
    };
    type LogpushResponse = {
        jobId?: number;
        name?: string;
        logType?: string;
        filter?: string;
        logFields?: Array<string>;
        destinationPath?: string;
        enabled?: boolean;
        lastComplete?: any;
        lastError?: any;
        errorMessage?: string;
        createdOn?: any;
    } & {
        [key: string]: any;
    };
    type Zone = {
        zoneId: string;
        name: string;
        status: string;
    } & {
        [key: string]: any;
    };
    type ZonesEnvelope = {
        data: Array<Zone>;
    } & {
        [key: string]: any;
    };
    type ItemResponseEnvelope = {
        data?: {} & {
            [key: string]: any;
        };
    } & {
        [key: string]: any;
    };
    type RateLimitingRuleEnvelope = {
        data: RateLimitingRule;
    } & {
        [key: string]: any;
    };
    type StorefrontZoneCreateRequest = {
        domainName: string;
    } & {
        [key: string]: any;
    };
    type LogpushCreateRequest = {
        destinationPath: string;
        name: string;
        filter?: string;
        logFields: Array<string>;
        ownershipChallengeToken: string;
        logType: string;
    } & {
        [key: string]: any;
    };
    type LogpushJobsEnvelope = {
        data: Array<LogpushResponse>;
    } & {
        [key: string]: any;
    };
    type RateLimitingRulesPostRequest = {
        description: string;
        expression: string;
        characteristics: Array<string>;
        action: string;
        period: number;
        requestsPerPeriod: number;
        mitigationTimeout?: number;
        countingExpression?: string;
        enabled?: boolean;
        position?: RulePosition;
    } & {
        [key: string]: any;
    };
    type WAFManagedRulesetRequest = {
        action?: string;
        anomalyScore?: string;
        paranoiaLevel?: number;
        enabled?: boolean;
    } & {
        [key: string]: any;
    };
    type CertificatesEnvelope = {
        data: Array<Certificate>;
    } & {
        [key: string]: any;
    };
    type WAFManagedRulesetsEnvelope = {
        data: Array<WAFManagedRuleset>;
    } & {
        [key: string]: any;
    };
    type MRTRulesResponse = {
        ruleset: MRTRuleset;
    } & {
        [key: string]: any;
    };
    type Hsts = {
        enabled?: boolean;
        includeSubdomains?: boolean;
        maxAge?: any;
        preload?: boolean;
    } & {
        [key: string]: any;
    };
    type SecuritySettingsEnvelope = {
        data: SecuritySetting;
    } & {
        [key: string]: any;
    };
    type RulePosition = {
        before?: string;
        after?: string;
    } & {
        [key: string]: any;
    };
    type CustomRulesPostRequest = {
        description: string;
        expression: string;
        actions: Array<string>;
        enabled?: boolean;
        position?: RulePosition;
    } & {
        [key: string]: any;
    };
    type LogpushUpdateRequest = {
        enabled?: boolean;
        filter?: string;
        logFields?: Array<string>;
    } & {
        [key: string]: any;
    };
    type ZoneEnvelope = {
        data: Zone;
    } & {
        [key: string]: any;
    };
    type SpeedSetting = {
        brotliCompression?: string;
        http2Prioritization?: string;
        webp?: string;
        polish?: string;
        minifyJs?: string;
        minifyHtml?: string;
        minifyCss?: string;
    } & {
        [key: string]: any;
    };
    type MRTRulePatchRequest = {
        enabled?: boolean;
        expression?: string;
    } & {
        [key: string]: any;
    };
    type CustomRulesEnvelope = {
        data: Array<CustomRule>;
    } & {
        [key: string]: any;
    };
    type WAFManagedRulesetEnvelope = {
        data: WAFManagedRuleset;
    } & {
        [key: string]: any;
    };
    type FirewallRuleEnvelope = {
        data: FirewallRule;
    } & {
        [key: string]: any;
    };
    type RateLimitingRulesPatchRequest = {
        description?: string;
        expression?: string;
        characteristics?: Array<string>;
        action?: string;
        period?: number;
        requestsPerPeriod?: number;
        mitigationTimeout?: number;
        countingExpression?: string;
        enabled?: boolean;
        position?: RulePosition;
    } & {
        [key: string]: any;
    };
    type FirewallRulesEnvelope = {
        data: Array<FirewallRule>;
    } & {
        [key: string]: any;
    };
    type CertificateRequest = {
        hostname: string;
        certificateType?: string;
        certificate?: string;
        privateKey?: string;
        certificateAuthority?: string;
        certificateValidation?: string;
    } & {
        [key: string]: any;
    };
    type RateLimitingRulesEnvelope = {
        data: Array<RateLimitingRule>;
    } & {
        [key: string]: any;
    };
    type CustomHostnameValidationResponse = {
        customHostnameId: string;
        customHostname: string;
        customHostnameVerificationTXTName: string;
        customHostnameVerificationTXTValue: string;
        customHostnameStatus: string;
    } & {
        [key: string]: any;
    };
    type LogpushOwnershipPostResponse = {
        data: {
            destinationPath: string;
            fileName: string;
        } & {
            [key: string]: any;
        };
    } & {
        [key: string]: any;
    };
    type MRTRulesPostRequest = {
        mrtHostname: string;
        expressions: Array<string>;
    } & {
        [key: string]: any;
    };
    type LogpushEnvelope = {
        data: LogpushResponse;
    } & {
        [key: string]: any;
    };
    type ErrorResponse = {
        type: string;
        title?: string;
        detail?: string;
        instance?: string;
    } & {
        [key: string]: any;
    };
    type MRTRulesResponseEnvelope = {
        data: MRTRulesResponse;
    } & {
        [key: string]: any;
    };
    type CustomRuleEnvelope = {
        data: CustomRule;
    } & {
        [key: string]: any;
    };
    type MRTRulesetPatchRequest = {
        oldMrtHostname?: string;
        mrtHostname: string;
        expressions?: Array<string>;
    } & {
        [key: string]: any;
    };
    type WafGroupsEnvelope = {
        data: Array<WafGroup>;
    } & {
        [key: string]: any;
    };
    type OCAPICachingToggleRequest = {
        enableOCAPICachingPageRule: boolean;
    } & {
        [key: string]: any;
    };
    type SecuritySetting = {
        hsts?: Hsts;
        securityLevel?: string;
        tls13Enabled?: boolean;
        wafEnabled?: boolean;
        alwaysUseHttps: boolean;
    } & {
        [key: string]: any;
    };
    type CustomRule = {
        ruleId: string;
        description: string;
        expression: string;
        actions: Array<string>;
        lastUpdated: any;
        enabled: boolean;
    } & {
        [key: string]: any;
    };
    type MRTRules = {
        id: string;
        expression: string;
        lastUpdated: any;
        ref: string;
        enabled: boolean;
        mrtHostname: string;
    } & {
        [key: string]: any;
    };
    type WafRulesEnvelope = {
        data: Array<WafRule>;
    } & {
        [key: string]: any;
    };
    type CertificateEnvelope = {
        data: Certificate;
    } & {
        [key: string]: any;
    };
    type CustomHostnameValidationEnvelope = {
        data: CustomHostnameValidationResponse;
    } & {
        [key: string]: any;
    };
    type RateLimitingRule = {
        ruleId: string;
        description: string;
        expression: string;
        characteristics: Array<string>;
        action: string;
        period: number;
        requestsPerPeriod: number;
        mitigationTimeout?: number;
        countingExpression?: string;
        lastUpdated: any;
        enabled: boolean;
    } & {
        [key: string]: any;
    };
    type CustomRulesPatchRequest = {
        description?: string;
        expression?: string;
        actions?: Array<string>;
        enabled?: boolean;
        position?: RulePosition;
    } & {
        [key: string]: any;
    };
    type StorefrontZoneCreateEnvelope = {
        data: StorefrontZoneCreateResponse;
    } & {
        [key: string]: any;
    };
    type WafGroup = {
        groupId?: string;
        action?: string;
        mode: string;
        description?: string;
    } & {
        [key: string]: any;
    };
    type Certificate = {
        certificateId: string;
        hosts?: Array<string>;
        expiresOn?: any;
        uploadedOn?: any;
        issuer?: string;
        signature?: string;
        status: string;
        minTlsVersion?: string;
        certificateType: string;
        certificateAuthority?: string;
        certificateValidation?: string;
        certificateVerificationTXTName?: string;
        certificateVerificationTXTValue?: string;
        certificateVerificationStatus?: string;
        customHostnameVerificationTXTName?: string;
        customHostnameVerificationTXTValue?: string;
        customHostnameId?: string;
        customHostname?: string;
        customHostnameStatus?: string;
    } & {
        [key: string]: any;
    };
    type CustomRulesPatchOrderRequest = {
        ruleIds: Array<string>;
    } & {
        [key: string]: any;
    };
    type WafRuleEnvelope = {
        data: WafRule;
    } & {
        [key: string]: any;
    };
    type CachePurgeResponse = {
        cachePurged: boolean;
        details: string;
    } & {
        [key: string]: any;
    };
    type WAFManagedRuleset = {
        name: string;
        rulesetId: string;
        action: string;
        anomalyScore?: string;
        anomalyScoreThreshold?: number;
        paranoiaLevel?: number;
        enabled: boolean;
    } & {
        [key: string]: any;
    };
    type MRTRuleset = {
        id: string;
        name: string;
        lastUpdated: any;
        rules: Array<MRTRules>;
    } & {
        [key: string]: any;
    };
    type WafRule = {
        ruleId?: string;
        groupId?: string;
        action: string;
        defaultAction?: string;
        description?: string;
    } & {
        [key: string]: any;
    };
    type Money = {
        currencyMnemonic?: string;
        value?: number;
    } & {
        [key: string]: any;
    };
    type SimpleSearchResult = {
        limit: number;
        hits?: Array<object>;
        offset: any;
        total: any;
    } & {
        [key: string]: any;
    };
    type SearchRequest = {
        limit?: number;
        query: any;
        sorts?: Array<Sort>;
        offset?: any;
    } & {
        [key: string]: any;
    };
    type PropertyDefinition = {
        defaultValue?: PropertyValueDefinition;
        id?: string;
        name: L10nString;
        description: L10nString;
        key?: boolean;
        localizable?: boolean;
        mandatory?: boolean;
        max?: number;
        minLength?: number;
        min?: number;
        multiValueType?: boolean;
        regularExpression?: string;
        scale?: number;
        searchable?: boolean;
        siteSpecific?: boolean;
        system?: boolean;
        unit?: L10nString;
        possibleValues?: Array<PropertyValueDefinition>;
        type: string;
        visible?: boolean;
    } & {
        [key: string]: any;
    };
    type LocalizedString = {} & {
        [key: string]: any;
    };
    type PaginatedSearchResult = {
        query: any;
        sorts?: Array<Sort>;
        limit: number;
        hits?: Array<object>;
        offset: any;
        total: any;
    } & {
        [key: string]: any;
    };
    type ClosedObject = {} & {
        [key: string]: any;
    };
    type OpenObject = {} & {
        [key: string]: any;
    };
    type NoPropertiesAllowed = {};
    type SpecifiedPropertiesAllowed = {} & {
        [key: string]: any;
    };
    type BoolFilter = {
        filters?: Array<any>;
        operator: string;
    } & {
        [key: string]: any;
    };
    type PaginatedSearchResultBase = {
        query: any;
        sorts?: Array<Sort>;
        limit: number;
        hits?: Array<object>;
        offset: any;
        total: any;
    } & {
        [key: string]: any;
    };
    type MatchAllQuery = {} & {
        [key: string]: any;
    };
    type FilteredQuery = {
        filter: any;
        query: any;
    } & {
        [key: string]: any;
    };
    type QueryFilter = {
        query: any;
    } & {
        [key: string]: any;
    };
    type Query = {
        boolQuery?: BoolQuery;
        filteredQuery?: FilteredQuery;
        matchAllQuery?: MatchAllQuery;
        nestedQuery?: NestedQuery;
        termQuery?: TermQuery;
        textQuery?: TextQuery;
    } & {
        [key: string]: any;
    };
    type TermQuery = {
        fields: Array<string>;
        operator: string;
        values?: Array<any>;
    } & {
        [key: string]: any;
    };
    type TermFilter = {
        field: string;
        operator: string;
        values?: Array<any>;
    } & {
        [key: string]: any;
    };
    type TextQuery = {
        fields: Array<string>;
        searchPhrase: string;
    } & {
        [key: string]: any;
    };
    type Range2Filter = {
        filterMode?: string;
        fromField: string;
        fromInclusive?: boolean;
        fromValue?: any;
        toField: string;
        toInclusive?: boolean;
        toValue?: any;
    } & {
        [key: string]: any;
    };
    type BoolQuery = {
        must?: Array<any>;
        mustNot?: Array<any>;
        should?: Array<any>;
    } & {
        [key: string]: any;
    };
    type SimpleSearchResultBase = {
        limit: number;
        hits?: Array<object>;
        offset: any;
        total: any;
    } & {
        [key: string]: any;
    };
    type NestedQuery = {
        path: string;
        query: any;
        scoreMode?: string;
    } & {
        [key: string]: any;
    };
    type Filter = {
        boolFilter?: BoolFilter;
        queryFilter?: QueryFilter;
        range2Filter?: Range2Filter;
        rangeFilter?: RangeFilter;
        termFilter?: TermFilter;
    } & {
        [key: string]: any;
    };
    type Sort = {
        field: string;
        sortOrder?: string;
    } & {
        [key: string]: any;
    };
    type RangeFilter = {
        field: string;
        from?: any;
        fromInclusive?: boolean;
        to?: any;
        toInclusive?: boolean;
    } & {
        [key: string]: any;
    };
    type SearchRequestBase = {
        limit?: number;
        query: any;
        sorts?: Array<Sort>;
        offset?: any;
    } & {
        [key: string]: any;
    };
    type MoneyMnemonic = {
        currencyMnemonic?: string;
        value?: number;
    } & {
        [key: string]: any;
    };
    type L10nString = {} & {
        [key: string]: any;
    };
    type AttributeDefinition = {
        defaultValue?: PropertyValueDefinition;
        id?: string;
        name: L10nString;
        description: L10nString;
        key?: boolean;
        localizable?: boolean;
        mandatory?: boolean;
        max?: number;
        minLength?: number;
        min?: number;
        multiValueType?: boolean;
        regularExpression?: string;
        scale?: number;
        searchable?: boolean;
        siteSpecific?: boolean;
        system?: boolean;
        unit?: L10nString;
        possibleValues?: Array<PropertyValueDefinition>;
        type: string;
        visible?: boolean;
    };
    type PropertyValueDefinition = {
        description: L10nString;
        displayValue: L10nString;
        id: string;
        position?: number;
        value: string;
    };
}
/**
* [CDN Zones](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=cdn-api-process-apis:Summary)
* ==================================
*
* *Extend your eCDN beyond Business Manager configuration.*<br />
*
*
* For instructions on how to retrieve access token for admin APIs: <a>https://developer.salesforce.com/docs/commerce/commerce-api/guide/authorization-for-admin-apis.html</a><br/><br/>
* Example with admin auth
*
* ```typescript
* import { Cdn, ClientConfig } from "commerce-sdk";
* // or
* const { Cdn, ClientConfig } = require("commerce-sdk");
*
* const clientConfig: ClientConfig = {
*   parameters: {
*     clientId: "XXXXXX",
*     organizationId: "XXXX",
*     shortCode: "XXX",
*     siteId: "XX"
*   }
* };
*
* token = { access_token: 'INSERT_ACCESS_TOKEN_HERE' };
*
* clientConfig.headers['authorization'] = `Bearer ${token.access_token}`;
* const cdnZonesClient = new Cdn.CdnZones(clientConfig);
* ```
*
* <span style="font-size:.7em; display:block; text-align: right">
* API Version: 1.0.30<br />
* Last Updated: <br />
* </span>

*

*/
export declare class CdnZones extends BaseClient {
    constructor(config: ClientConfig);
    /**
    * Create a new storefront zone.
    *
    * If you would like to get a raw Response object use the other createStorefrontZone function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.StorefrontZoneCreateEnvelope.
    *
    */
    createStorefrontZone(options: {
        parameters?: {
            organizationId?: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.StorefrontZoneCreateRequest;
    }): Promise<CdnZones.StorefrontZoneCreateEnvelope>;
    /**
    * Create a new storefront zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.StorefrontZoneCreateEnvelope otherwise.
    *
    */
    createStorefrontZone<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.StorefrontZoneCreateRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.StorefrontZoneCreateEnvelope>;
    /**
    * Retrieves zone information.
    *
    * If you would like to get a raw Response object use the other getZonesInfo function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param offset -
    * @param limit - Maximum records to retrieve per request, not to exceed 50. Defaults to 25.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.ZonesEnvelope.
    *
    */
    getZonesInfo(options?: {
        parameters?: {
            organizationId?: string;
            offset?: any;
            limit?: number;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.ZonesEnvelope>;
    /**
    * Retrieves zone information.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param offset -
    * @param limit - Maximum records to retrieve per request, not to exceed 50. Defaults to 25.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.ZonesEnvelope otherwise.
    *
    */
    getZonesInfo<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            offset?: any;
            limit?: number;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.ZonesEnvelope>;
    /**
    * Retrieves all WAF groups accessible to the caller. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * If you would like to get a raw Response object use the other getWafGroups function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.WafGroupsEnvelope.
    *
    */
    getWafGroups(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.WafGroupsEnvelope>;
    /**
    * Retrieves all WAF groups accessible to the caller. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WafGroupsEnvelope otherwise.
    *
    */
    getWafGroups<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WafGroupsEnvelope>;
    /**
    * Updates action or mode of a specific WAF group. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * If you would like to get a raw Response object use the other updateWafGroup function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param groupId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.WafGroupEnvelope.
    *
    */
    updateWafGroup(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            groupId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.WafGroup;
    }): Promise<CdnZones.WafGroupEnvelope>;
    /**
    * Updates action or mode of a specific WAF group. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param groupId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WafGroupEnvelope otherwise.
    *
    */
    updateWafGroup<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            groupId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.WafGroup;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WafGroupEnvelope>;
    /**
    * Retrieves WAF rules under the waf group specified by the caller. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * If you would like to get a raw Response object use the other getWafRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param groupId - WAF Group that contains the WAF rules.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.WafRulesEnvelope.
    *
    */
    getWafRules(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            groupId?: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.WafRulesEnvelope>;
    /**
    * Retrieves WAF rules under the waf group specified by the caller. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param groupId - WAF Group that contains the WAF rules.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WafRulesEnvelope otherwise.
    *
    */
    getWafRules<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            groupId?: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WafRulesEnvelope>;
    /**
    * Retrieves details of a specific WAF rule. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * If you would like to get a raw Response object use the other getWafRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.WafRuleEnvelope.
    *
    */
    getWafRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.WafRuleEnvelope>;
    /**
    * Retrieves details of a specific WAF rule. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WafRuleEnvelope otherwise.
    *
    */
    getWafRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WafRuleEnvelope>;
    /**
    * Updates action of a specific WAF rule. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * If you would like to get a raw Response object use the other updateWafRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.WafRuleEnvelope.
    *
    */
    updateWafRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.WafRule;
    }): Promise<CdnZones.WafRuleEnvelope>;
    /**
    * Updates action of a specific WAF rule. Not applicable for zones using WAFv2. For any zones created after the 24.5 release, use the endpoints for WAF managed rulesets instead.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WafRuleEnvelope otherwise.
    *
    */
    updateWafRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.WafRule;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WafRuleEnvelope>;
    /**
    * (DEPRECATED) Retrieves existing firewall rules. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * If you would like to get a raw Response object use the other getFirewallRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.FirewallRulesEnvelope.
    *
    */
    getFirewallRules(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.FirewallRulesEnvelope>;
    /**
    * (DEPRECATED) Retrieves existing firewall rules. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.FirewallRulesEnvelope otherwise.
    *
    */
    getFirewallRules<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.FirewallRulesEnvelope>;
    /**
    * (DEPRECATED) Creates a firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * If you would like to get a raw Response object use the other createFirewallRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.FirewallRuleEnvelope.
    *
    */
    createFirewallRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.FirewallRule;
    }): Promise<CdnZones.FirewallRuleEnvelope>;
    /**
    * (DEPRECATED) Creates a firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.FirewallRuleEnvelope otherwise.
    *
    */
    createFirewallRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.FirewallRule;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.FirewallRuleEnvelope>;
    /**
    * (DEPRECATED) Retrieve a specific firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * If you would like to get a raw Response object use the other getFirewallRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param firewallRuleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.FirewallRuleEnvelope.
    *
    */
    getFirewallRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            firewallRuleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.FirewallRuleEnvelope>;
    /**
    * (DEPRECATED) Retrieve a specific firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param firewallRuleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.FirewallRuleEnvelope otherwise.
    *
    */
    getFirewallRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            firewallRuleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.FirewallRuleEnvelope>;
    /**
    * (DEPRECATED) Update a specific firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * If you would like to get a raw Response object use the other updateFirewallRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param firewallRuleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.FirewallRuleEnvelope.
    *
    */
    updateFirewallRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            firewallRuleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.FirewallRule;
    }): Promise<CdnZones.FirewallRuleEnvelope>;
    /**
    * (DEPRECATED) Update a specific firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param firewallRuleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.FirewallRuleEnvelope otherwise.
    *
    */
    updateFirewallRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            firewallRuleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.FirewallRule;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.FirewallRuleEnvelope>;
    /**
    * (DEPRECATED) Delete a specific firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * If you would like to get a raw Response object use the other deleteFirewallRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param firewallRuleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteFirewallRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            firewallRuleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * (DEPRECATED) Delete a specific firewall rule. This endpoint is deprecated. Requests return a 400 Bad Request response. Use [eCDN custom rules](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-zones-custom-rules.html) moving forward. Any existing firewall rules are accessible and can be updated using the custom rule endpoints.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param firewallRuleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteFirewallRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            firewallRuleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Retrieve speed settings for a zone.
    *
    * If you would like to get a raw Response object use the other getSpeedSettings function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.SpeedSettingsEnvelope.
    *
    */
    getSpeedSettings(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.SpeedSettingsEnvelope>;
    /**
    * Retrieve speed settings for a zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.SpeedSettingsEnvelope otherwise.
    *
    */
    getSpeedSettings<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.SpeedSettingsEnvelope>;
    /**
    * Update speed settings for a zone.
    *
    * If you would like to get a raw Response object use the other updateSpeedSettings function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.SpeedSettingsEnvelope.
    *
    */
    updateSpeedSettings(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.SpeedSetting;
    }): Promise<CdnZones.SpeedSettingsEnvelope>;
    /**
    * Update speed settings for a zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.SpeedSettingsEnvelope otherwise.
    *
    */
    updateSpeedSettings<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.SpeedSetting;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.SpeedSettingsEnvelope>;
    /**
    * Retrieve security settings for a zone.
    *
    * If you would like to get a raw Response object use the other getSecuritySettings function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.SecuritySettingsEnvelope.
    *
    */
    getSecuritySettings(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.SecuritySettingsEnvelope>;
    /**
    * Retrieve security settings for a zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.SecuritySettingsEnvelope otherwise.
    *
    */
    getSecuritySettings<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.SecuritySettingsEnvelope>;
    /**
    * Update security settings for a zone.
    *
    * If you would like to get a raw Response object use the other updateSecuritySettings function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.SecuritySettingsEnvelope.
    *
    */
    updateSecuritySettings(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.SecuritySetting;
    }): Promise<CdnZones.SecuritySettingsEnvelope>;
    /**
    * Update security settings for a zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.SecuritySettingsEnvelope otherwise.
    *
    */
    updateSecuritySettings<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.SecuritySetting;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.SecuritySettingsEnvelope>;
    /**
    * Request to purge the cache for the host given in the request body
    *
    * If you would like to get a raw Response object use the other cachePurge function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CachePurgeResponseEnvelope.
    *
    */
    cachePurge(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CachePurgeRequest;
    }): Promise<CdnZones.CachePurgeResponseEnvelope>;
    /**
    * Request to purge the cache for the host given in the request body
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CachePurgeResponseEnvelope otherwise.
    *
    */
    cachePurge<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CachePurgeRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CachePurgeResponseEnvelope>;
    /**
    * Request to enable or disable OCAPI Caching page rule.
    *
    * If you would like to get a raw Response object use the other toggleOcapiCachingPageRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.OCAPICachingToggleRequest.
    *
    */
    toggleOcapiCachingPageRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.OCAPICachingToggleRequest;
    }): Promise<CdnZones.OCAPICachingToggleRequest>;
    /**
    * Request to enable or disable OCAPI Caching page rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.OCAPICachingToggleRequest otherwise.
    *
    */
    toggleOcapiCachingPageRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.OCAPICachingToggleRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.OCAPICachingToggleRequest>;
    /**
    * Retrieves a list of certificates information for a zone.
    *
    * If you would like to get a raw Response object use the other getCertificates function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param offset -
    * @param limit - Maximum records to retrieve per request, not to exceed 50. Defaults to 25.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.CertificatesEnvelope.
    *
    */
    getCertificates(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            offset?: any;
            limit?: number;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.CertificatesEnvelope>;
    /**
    * Retrieves a list of certificates information for a zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param offset -
    * @param limit - Maximum records to retrieve per request, not to exceed 50. Defaults to 25.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CertificatesEnvelope otherwise.
    *
    */
    getCertificates<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            offset?: any;
            limit?: number;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CertificatesEnvelope>;
    /**
    * Add Certificates For Zone
    *
    * If you would like to get a raw Response object use the other addCertificateForZone function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CertificateEnvelope.
    *
    */
    addCertificateForZone(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CertificateRequest;
    }): Promise<CdnZones.CertificateEnvelope>;
    /**
    * Add Certificates For Zone
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CertificateEnvelope otherwise.
    *
    */
    addCertificateForZone<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CertificateRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CertificateEnvelope>;
    /**
    * This action deletes a custom hostname and the certificate associated with it. Note that a valid certificate is necessary for a site to remain operational. DELETING AN IN-USE CERTIFICATE MAY RESULT IN DOWNTIME.
    *
    * If you would like to get a raw Response object use the other deleteCertificate function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param certificateId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteCertificate(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            certificateId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * This action deletes a custom hostname and the certificate associated with it. Note that a valid certificate is necessary for a site to remain operational. DELETING AN IN-USE CERTIFICATE MAY RESULT IN DOWNTIME.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param certificateId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteCertificate<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            certificateId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Updates the certificate for a given certificateId for a particular zone.
    *
    * If you would like to get a raw Response object use the other updateCertificate function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param certificateId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CertificateEnvelope.
    *
    */
    updateCertificate(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            certificateId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CertificateRequest;
    }): Promise<CdnZones.CertificateEnvelope>;
    /**
    * Updates the certificate for a given certificateId for a particular zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param certificateId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CertificateEnvelope otherwise.
    *
    */
    updateCertificate<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            certificateId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CertificateRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CertificateEnvelope>;
    /**
    * Trigger the validation of a custom hostname.
    *
    * If you would like to get a raw Response object use the other validateCustomHostname function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param customHostnameId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CustomHostnameValidationEnvelope.
    *
    */
    validateCustomHostname(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            customHostnameId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: object;
    }): Promise<CdnZones.CustomHostnameValidationEnvelope>;
    /**
    * Trigger the validation of a custom hostname.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param customHostnameId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CustomHostnameValidationEnvelope otherwise.
    *
    */
    validateCustomHostname<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            customHostnameId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: object;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CustomHostnameValidationEnvelope>;
    /**
    * Create MRT rules.
    *
    * If you would like to get a raw Response object use the other createMrtRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.MRTRulesResponseEnvelope.
    *
    */
    createMrtRules(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.MRTRulesPostRequest;
    }): Promise<CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Create MRT rules.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.MRTRulesResponseEnvelope otherwise.
    *
    */
    createMrtRules<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.MRTRulesPostRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Update the MRT hostname or add MRT rules to the ruleset.
    *
    * If you would like to get a raw Response object use the other updateMrtRuleset function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.MRTRulesResponseEnvelope.
    *
    */
    updateMrtRuleset(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.MRTRulesetPatchRequest;
    }): Promise<CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Update the MRT hostname or add MRT rules to the ruleset.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.MRTRulesResponseEnvelope otherwise.
    *
    */
    updateMrtRuleset<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.MRTRulesetPatchRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Get MRT rules associated with a zone.
    *
    * If you would like to get a raw Response object use the other getMrtRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.MRTRulesResponseEnvelope.
    *
    */
    getMrtRules(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Get MRT rules associated with a zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.MRTRulesResponseEnvelope otherwise.
    *
    */
    getMrtRules<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Delete the MRT ruleset specified for that particular zone.
    *
    * If you would like to get a raw Response object use the other deleteMrtRuleset function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteMrtRuleset(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * Delete the MRT ruleset specified for that particular zone.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteMrtRuleset<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Delete an MRT rule in the specified ruleset.
    *
    * If you would like to get a raw Response object use the other deleteMrtRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteMrtRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * Delete an MRT rule in the specified ruleset.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteMrtRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Update the expression and enable or disable an MRT rule.
    *
    * If you would like to get a raw Response object use the other updateMrtRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.MRTRulesResponseEnvelope.
    *
    */
    updateMrtRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.MRTRulePatchRequest;
    }): Promise<CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Update the expression and enable or disable an MRT rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.MRTRulesResponseEnvelope otherwise.
    *
    */
    updateMrtRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.MRTRulePatchRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.MRTRulesResponseEnvelope>;
    /**
    * Create Logpush ownership token file.
    *
    * If you would like to get a raw Response object use the other createLogpushOwnership function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.LogpushOwnershipPostResponse.
    *
    */
    createLogpushOwnership(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.LogpushOwnershipPostRequest;
    }): Promise<CdnZones.LogpushOwnershipPostResponse>;
    /**
    * Create Logpush ownership token file.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.LogpushOwnershipPostResponse otherwise.
    *
    */
    createLogpushOwnership<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.LogpushOwnershipPostRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.LogpushOwnershipPostResponse>;
    /**
    * Create Logpush job.
    *
    * If you would like to get a raw Response object use the other createLogpushJob function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.LogpushEnvelope.
    *
    */
    createLogpushJob(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.LogpushCreateRequest;
    }): Promise<CdnZones.LogpushEnvelope>;
    /**
    * Create Logpush job.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.LogpushEnvelope otherwise.
    *
    */
    createLogpushJob<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.LogpushCreateRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.LogpushEnvelope>;
    /**
    * List Logpush job.
    *
    * If you would like to get a raw Response object use the other listLogpushJob function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.LogpushJobsEnvelope.
    *
    */
    listLogpushJob(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.LogpushJobsEnvelope>;
    /**
    * List Logpush job.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.LogpushJobsEnvelope otherwise.
    *
    */
    listLogpushJob<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.LogpushJobsEnvelope>;
    /**
    * Get Logpush job details.
    *
    * If you would like to get a raw Response object use the other getLogpushJob function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param jobId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.LogpushEnvelope.
    *
    */
    getLogpushJob(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            jobId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.LogpushEnvelope>;
    /**
    * Get Logpush job details.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param jobId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.LogpushEnvelope otherwise.
    *
    */
    getLogpushJob<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            jobId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.LogpushEnvelope>;
    /**
    * Update Logpush job.
    *
    * If you would like to get a raw Response object use the other updateLogpushJob function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param jobId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.LogpushEnvelope.
    *
    */
    updateLogpushJob(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            jobId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.LogpushUpdateRequest;
    }): Promise<CdnZones.LogpushEnvelope>;
    /**
    * Update Logpush job.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param jobId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.LogpushEnvelope otherwise.
    *
    */
    updateLogpushJob<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            jobId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.LogpushUpdateRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.LogpushEnvelope>;
    /**
    * Delete Logpush job by job ID.
    *
    * If you would like to get a raw Response object use the other deleteLogpushJob function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param jobId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteLogpushJob(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            jobId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * Delete Logpush job by job ID.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param jobId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteLogpushJob<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            jobId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Creates a custom rule.
    *
    * If you would like to get a raw Response object use the other createCustomRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CustomRuleEnvelope.
    *
    */
    createCustomRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CustomRulesPostRequest;
    }): Promise<CdnZones.CustomRuleEnvelope>;
    /**
    * Creates a custom rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CustomRuleEnvelope otherwise.
    *
    */
    createCustomRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CustomRulesPostRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CustomRuleEnvelope>;
    /**
    * Retrieves existing custom rules.
    *
    * If you would like to get a raw Response object use the other getCustomRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param offset -
    * @param limit - Maximum records to retrieve per request, not to exceed 50. Defaults to 25.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.CustomRulesEnvelope.
    *
    */
    getCustomRules(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            offset?: any;
            limit?: number;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.CustomRulesEnvelope>;
    /**
    * Retrieves existing custom rules.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param offset -
    * @param limit - Maximum records to retrieve per request, not to exceed 50. Defaults to 25.
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CustomRulesEnvelope otherwise.
    *
    */
    getCustomRules<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            offset?: any;
            limit?: number;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CustomRulesEnvelope>;
    /**
    * Updates the order of all existing custom rules.
    *
    * If you would like to get a raw Response object use the other updateOrderOfCustomRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CustomRulesEnvelope.
    *
    */
    updateOrderOfCustomRules(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CustomRulesPatchOrderRequest;
    }): Promise<CdnZones.CustomRulesEnvelope>;
    /**
    * Updates the order of all existing custom rules.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CustomRulesEnvelope otherwise.
    *
    */
    updateOrderOfCustomRules<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CustomRulesPatchOrderRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CustomRulesEnvelope>;
    /**
    * Retrieves a specific custom rule.
    *
    * If you would like to get a raw Response object use the other getCustomRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.CustomRuleEnvelope.
    *
    */
    getCustomRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.CustomRuleEnvelope>;
    /**
    * Retrieves a specific custom rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CustomRuleEnvelope otherwise.
    *
    */
    getCustomRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CustomRuleEnvelope>;
    /**
    * Updates a specific custom rule.
    *
    * If you would like to get a raw Response object use the other updateCustomRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.CustomRuleEnvelope.
    *
    */
    updateCustomRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CustomRulesPatchRequest;
    }): Promise<CdnZones.CustomRuleEnvelope>;
    /**
    * Updates a specific custom rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.CustomRuleEnvelope otherwise.
    *
    */
    updateCustomRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.CustomRulesPatchRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.CustomRuleEnvelope>;
    /**
    * Deletes a specific custom rule.
    *
    * If you would like to get a raw Response object use the other deleteCustomRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteCustomRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * Deletes a specific custom rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteCustomRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Creates a rate limiting rule.
    *
    * If you would like to get a raw Response object use the other createRateLimitingRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.RateLimitingRuleEnvelope.
    *
    */
    createRateLimitingRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.RateLimitingRulesPostRequest;
    }): Promise<CdnZones.RateLimitingRuleEnvelope>;
    /**
    * Creates a rate limiting rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.RateLimitingRuleEnvelope otherwise.
    *
    */
    createRateLimitingRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.RateLimitingRulesPostRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.RateLimitingRuleEnvelope>;
    /**
    * Retrieves existing rate limiting rules.
    *
    * If you would like to get a raw Response object use the other getRateLimitingRules function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.RateLimitingRulesEnvelope.
    *
    */
    getRateLimitingRules(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.RateLimitingRulesEnvelope>;
    /**
    * Retrieves existing rate limiting rules.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.RateLimitingRulesEnvelope otherwise.
    *
    */
    getRateLimitingRules<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.RateLimitingRulesEnvelope>;
    /**
    * Retrieves a specific rate limiting rule.
    *
    * If you would like to get a raw Response object use the other getRateLimitingRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.RateLimitingRuleEnvelope.
    *
    */
    getRateLimitingRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.RateLimitingRuleEnvelope>;
    /**
    * Retrieves a specific rate limiting rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.RateLimitingRuleEnvelope otherwise.
    *
    */
    getRateLimitingRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.RateLimitingRuleEnvelope>;
    /**
    * Updates a specific rate limiting rule.
    *
    * If you would like to get a raw Response object use the other updateRateLimitingRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.RateLimitingRuleEnvelope.
    *
    */
    updateRateLimitingRule(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.RateLimitingRulesPatchRequest;
    }): Promise<CdnZones.RateLimitingRuleEnvelope>;
    /**
    * Updates a specific rate limiting rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.RateLimitingRuleEnvelope otherwise.
    *
    */
    updateRateLimitingRule<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.RateLimitingRulesPatchRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.RateLimitingRuleEnvelope>;
    /**
    * Deletes a specific rate limiting rule.
    *
    * If you would like to get a raw Response object use the other deleteRateLimitingRule function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type void.
    *
    */
    deleteRateLimitingRule(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<void>;
    /**
    * Deletes a specific rate limiting rule.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param ruleId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type void otherwise.
    *
    */
    deleteRateLimitingRule<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            ruleId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : void>;
    /**
    * Retrieves WAFv2 managed rulesets.
    *
    * If you would like to get a raw Response object use the other getWafManagedRulesets function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    *
    * @returns A promise of type CdnZones.WAFManagedRulesetsEnvelope.
    *
    */
    getWafManagedRulesets(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }): Promise<CdnZones.WAFManagedRulesetsEnvelope>;
    /**
    * Retrieves WAFv2 managed rulesets.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WAFManagedRulesetsEnvelope otherwise.
    *
    */
    getWafManagedRulesets<T extends boolean>(options?: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WAFManagedRulesetsEnvelope>;
    /**
    * Updates WAFv2 managed ruleset.
    *
    * If you would like to get a raw Response object use the other updateWafManagedRuleset function.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    *
    * @returns A promise of type CdnZones.WAFManagedRulesetEnvelope.
    *
    */
    updateWafManagedRuleset(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.WAFManagedRulesetRequest;
    }): Promise<CdnZones.WAFManagedRulesetEnvelope>;
    /**
    * Updates WAFv2 managed ruleset.
    *
    * @param options - An object containing the options for this method.
    * @param parameters - An object containing the parameters for this method.
    * @param organizationId -
    * @param zoneId -
    * @param rulesetId -
    * @param headers - An object literal of key value pairs of the headers to be
    * sent with this request.
    * @param body - The data to send as the request body.
    * @param rawResponse - Set to true to return entire Response object instead of DTO.
    *
    * @returns A promise of type Response if rawResponse is true, a promise of type CdnZones.WAFManagedRulesetEnvelope otherwise.
    *
    */
    updateWafManagedRuleset<T extends boolean>(options: {
        parameters?: {
            organizationId?: string;
            zoneId: string;
            rulesetId: string;
        } & {
            [key in `c_${string}`]: any;
        };
        retrySettings?: OperationOptions;
        fetchOptions?: RequestInit;
        headers?: {
            [key: string]: string;
        };
        body: CdnZones.WAFManagedRulesetRequest;
    }, rawResponse?: T): Promise<T extends true ? Response : CdnZones.WAFManagedRulesetEnvelope>;
}
